/*
 * Copyright (c) 2015, University of Kaiserslautern
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * Authors:
 *    Janik Schlemminger
 *    Robert Gernhardt
 *    Matthias Jung
 *    Felipe S. Prado
 */

#include "PowerDownManagerTimeoutBankwise.h"
#include "../ControllerCore.h"
#include "../../../common/Utils.h"
#include "../../../common/DebugManager.h"
#include "../TimingCalculation.h"

using namespace tlm;

PowerDownManagerTimeoutBankwise::PowerDownManagerTimeoutBankwise(
    sc_module_name name, ControllerCore &controllerCore):
    PowerDownManagerBankwise(name, controllerCore)
{
    /*for (Bank bank : controllerCore.getBanks())
    {
        controllerCore.controller.send(PDNTrigger, controllerCore.config.getPowerDownTimeout(), powerDownPayloads[bank]);
    }*/
}

PowerDownManagerTimeoutBankwise::~PowerDownManagerTimeoutBankwise()
{
    // TODO Auto-generated destructor stub
}

void PowerDownManagerTimeoutBankwise::sleep(Bank bank, sc_time time)
{
    bool timeoutTest;
    if (!isAwakeForRefresh(bank)) {
        sc_time lastReadScheduled;
        sc_time lastWriteScheduled;
        if (Configuration::getInstance().OpenPagePolicy) {
            lastReadScheduled = controllerCore.state->getLastCommand(Command::Read,
                                                                     bank).getEnd();
            lastWriteScheduled = controllerCore.state->getLastCommand(Command::Write,
                                                                      bank).getEnd();
        } else {
            lastReadScheduled = controllerCore.state->getLastCommand(Command::ReadA,
                                                                     bank).getEnd();
            lastWriteScheduled = controllerCore.state->getLastCommand(Command::WriteA,
                                                                      bank).getEnd();
        }
        sc_time lastScheduledCommand = max(lastReadScheduled, lastWriteScheduled);
        timeoutTest = (time - lastScheduledCommand) >=
                      Configuration::getInstance().getPowerDownTimeout();
    } else {
        timeoutTest = true;
    }

    if ( canSleep(bank) && !isInPowerDown(bank) && timeoutTest) {
        PowerDownState newState;
        if (Configuration::getInstance().PowerDownMode == EPowerDownMode::TimeoutPDN) {
            newState = controllerCore.state->rowBufferStates->rowBufferIsOpen(
                           bank) ? PowerDownState::PDNActive : PowerDownState::PDNPrecharge;
        } else { // PowerDownMode == TimeoutSREF
            if (controllerCore.state->rowBufferStates->rowBufferIsOpen(bank)) {
                ScheduledCommand precharge(Command::Precharge, time,
                                           getExecutionTime(Command::Precharge, powerDownPayloads[bank]),
                                           DramExtension::getExtension(powerDownPayloads[bank]));

                controllerCore.getCommandChecker(Command::Precharge).delayToSatisfyConstraints(
                    precharge);

                if (controllerCore.refreshManager->hasCollision(precharge)) {
                    return;
                } else {
                    controllerCore.state->change(precharge);
                    controllerCore.controller.send(precharge, powerDownPayloads[bank]);
                }

            }

            newState = PowerDownState::PDNSelfRefresh;
        }


        Command cmd = IPowerDownManager::getSleepCommand(newState);
        ScheduledCommand pdn(cmd, time, getMinExecutionTimeForPowerDownCmd(cmd),
                             DramExtension::getExtension(powerDownPayloads[bank]));

        controllerCore.getCommandChecker(cmd).delayToSatisfyConstraints(pdn);

        if (controllerCore.refreshManager->hasCollision(pdn)) {
            return;
        } else {
            setPowerDownState(newState, bank);
            sendPowerDownPayload(pdn);
        }
    }
}

void PowerDownManagerTimeoutBankwise::triggerSleep(Bank bank, sc_time time)
{
    if (canSleep(bank) && !isInPowerDown(bank)) {
        controllerCore.controller.send(PDNTrigger,
                                       time + controllerCore.config.getPowerDownTimeout(), powerDownPayloads[bank]);
    }
}
